package org.dromara.personnel.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.personnel.domain.bo.OpsEquipmentBo;
import org.dromara.personnel.domain.vo.OpsEquipmentVo;
import org.dromara.personnel.domain.OpsEquipment;
import org.dromara.personnel.mapper.OpsEquipmentMapper;
import org.dromara.personnel.service.IOpsEquipmentService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 运维-设备Service业务层处理
 *
 * @author LionLi
 * @date 2025-09-19
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class OpsEquipmentServiceImpl extends ServiceImpl<OpsEquipmentMapper,OpsEquipment> implements IOpsEquipmentService {

    private final OpsEquipmentMapper baseMapper;

    /**
     * 查询运维-设备
     *
     * @param id 主键
     * @return 运维-设备
     */
    @Override
    public OpsEquipmentVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询运维-设备列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 运维-设备分页列表
     */
    @Override
    public TableDataInfo<OpsEquipmentVo> queryPageList(OpsEquipmentBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<OpsEquipment> lqw = buildQueryWrapper(bo);
        Page<OpsEquipmentVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的运维-设备列表
     *
     * @param bo 查询条件
     * @return 运维-设备列表
     */
    @Override
    public List<OpsEquipmentVo> queryList(OpsEquipmentBo bo) {
        LambdaQueryWrapper<OpsEquipment> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<OpsEquipment> buildQueryWrapper(OpsEquipmentBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<OpsEquipment> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(OpsEquipment::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getDeviceId()), OpsEquipment::getDeviceId, bo.getDeviceId());
        lqw.like(StringUtils.isNotBlank(bo.getDeviceName()), OpsEquipment::getDeviceName, bo.getDeviceName());
        lqw.eq(StringUtils.isNotBlank(bo.getDeviceType()), OpsEquipment::getDeviceType, bo.getDeviceType());
        lqw.eq(StringUtils.isNotBlank(bo.getAffiliationPowerStation()), OpsEquipment::getAffiliationPowerStation, bo.getAffiliationPowerStation());
        lqw.eq(StringUtils.isNotBlank(bo.getCommProtocol()), OpsEquipment::getCommProtocol, bo.getCommProtocol());
        lqw.eq(StringUtils.isNotBlank(bo.getIpAdd()), OpsEquipment::getIpAdd, bo.getIpAdd());
        lqw.eq(bo.getLastOnlineTime() != null, OpsEquipment::getLastOnlineTime, bo.getLastOnlineTime());
        lqw.eq(StringUtils.isNotBlank(bo.getStatus()), OpsEquipment::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增运维-设备
     *
     * @param bo 运维-设备
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(OpsEquipmentBo bo) {
        OpsEquipment add = MapstructUtils.convert(bo, OpsEquipment.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改运维-设备
     *
     * @param bo 运维-设备
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(OpsEquipmentBo bo) {
        OpsEquipment update = MapstructUtils.convert(bo, OpsEquipment.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(OpsEquipment entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除运维-设备信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
